#region -- BSD Licence --
/*
Copyright (c) 2003, 5D Services
http://www.ihook.cc
OpenSource@ihook.cc
lloyd@5dservices.com.au
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer. 

Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution. 

Neither the name of "5D Services" nor the names of its contributors may be
used to endorse or promote products derived from this software without
specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/
#endregion
using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

using ihook.PocketWidgets;
using ihook.PocketWidgets.Icons;
using ihook.PocketWidgets.Utils;

namespace ihook.PocketWidgets.Editors
{
	/// <summary>
	/// an editor to pick an object into a list, it's just a combo box.
	/// </summary>
	/*public class ListEditor : ComboBox, IEditor
	{
		public ListEditor()
		{
			SelectedIndexChanged += new EventHandler(HSelectionChanged);
		}
		public ListEditor(IList l) : this()
		{
			List = l;
		}

		public IList List
		{
			set { DataSource = value; }
			get { return (IList) DataSource; }
		}
		#region IEditor Members

		public Control Control
		{
			get { return this; }
		}

		public object Value
		{
			get { return SelectedItem; }
			set { SelectedItem = value; }
		}
		bool isNull;
		public bool IsNull
		{
			get 
			{
				if(isNull)
					return true;
				return SelectedItem == null;
			}
			set
			{
				SelectedItem = null;
				isNull = true;
				if(ValueChanged != null)
					ValueChanged(this, EventArgs.Empty);
			}
		}
		private void HSelectionChanged(object sender, EventArgs e)
		{
			isNull = false;
			if(ValueChanged != null)
				ValueChanged(this, EventArgs.Empty);
		}

		public event System.EventHandler ValueChanged;

		#endregion
	}*/
	/// <summary>
	/// a replacement for the combo box ...
	/// </summary>
	public class ListEditor : EditableListEditor
	{
		public ListEditor()
		{
			LabelEditor le = new LabelEditor();
			le.ForeColor = Color.Black;
			CellEditor = le;
		}
		public ListEditor(IList l) : this()
		{
			base.ListSource = l;
		}

		public IList List
		{
			set { ListSource = value; }
			get { return (IList) ListSource; }
		}
		public IList DataSource
		{
			set { ListSource = value; }
			get { return (IList) ListSource; }
		}
		public object SelectedItem { get { return Value; } }

		#region IEditor Members

		/*public Control Control
		{
			get { return this; }
		}

		public object Value
		{
			get { return SelectedItem; }
			set { SelectedItem = value; }
		}
		bool isNull;
		public bool IsNull
		{
			get 
			{
				if(isNull)
					return true;
				return SelectedItem == null;
			}
			set
			{
				SelectedItem = null;
				isNull = true;
				if(ValueChanged != null)
					ValueChanged(this, EventArgs.Empty);
			}
		}
		private void HSelectionChanged(object sender, EventArgs e)
		{
			isNull = false;
			if(ValueChanged != null)
				ValueChanged(this, EventArgs.Empty);
		}

		public event System.EventHandler ValueChanged;*/

		#endregion
	}
}
