#region -- BSD Licence --
/*
Copyright (c) 2003, 5D Services
http://www.ihook.cc
OpenSource@ihook.cc
lloyd@5dservices.com.au
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer. 

Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution. 

Neither the name of "5D Services" nor the names of its contributors may be
used to endorse or promote products derived from this software without
specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/
#endregion
using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

using ihook.PocketWidgets;
using ihook.PocketWidgets.Icons;
using ihook.PocketWidgets.Utils;

namespace ihook.PocketWidgets.Editors
{
	/// <summary>
	/// Summary description for TextEditor.
	/// </summary>
	public class TextEditor : TextBox, IEditor
	{
		public TextEditor()
		{
			//Validated += new EventHandler(HValidated);
			TextChanged += new EventHandler(HChanged);
		}
		#region IEditor Members

		bool dontUpdate = false;

		public Control Control
		{
			get { return this; }
		}

		public object Value
		{
			get 
			{ 
				if(isNull)
					return null;
				return Text; 
			}
			set 
			{ 
				dontUpdate = false;
				try
				{
					if(value == null || value == DBNull.Value)
					{
						Text = "";
						isNull = true;
					}
					else
					{
						isNull = false;
						Text = (string) value; 
					}
				}
				finally { dontUpdate = false; }
				HValidated(this, EventArgs.Empty);
			}
		}
		bool isNull;
		public bool IsNull
		{
			get { return isNull; }
			set 
			{
				dontUpdate = true;
				try
				{
					if(value)
					{
						Text = "";
						isNull = true;
					}
					else
					{
						isNull = false;
					}
				}
				finally { dontUpdate = false; }
				HValidated(this, EventArgs.Empty);
			}
		}

		public event System.EventHandler ValueChanged;

		#endregion

		private void HChanged(object sender, EventArgs e)
		{
			isNull = false;
			FireChanged();
		}
		private void HValidated(object sender, EventArgs e)
		{
			FireChanged();
		}
		void FireChanged()
		{
			if(!dontUpdate && ValueChanged != null)
				ValueChanged(this, EventArgs.Empty);
		}
	}
}
