#region -- BSD Licence --
/*
Copyright (c) 2003, 5D Services
http://www.ihook.cc
OpenSource@ihook.cc
lloyd@5dservices.com.au
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer. 

Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution. 

Neither the name of "5D Services" nor the names of its contributors may be
used to endorse or promote products derived from this software without
specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/
#endregion
using System;
using System.Drawing;
using System.Windows.Forms;

namespace ihook.PocketWidgets.HTML
{
	/// <summary>
	/// Summary description for HTMLControl.
	/// </summary>
	public class HTMLForm : Form
	{
		HTMLViewer htmlViewer;
		bool created = false;

		public HTMLForm()
		{
			htmlViewer = new HTMLViewer();
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad (e);
			string s = Text;
			Text = "HtmlViewer --- ID -- "+new Random().Next();
			htmlViewer.ParentForm = this;
			htmlViewer.CreateHTMLControl();
			Text = s;
			created = true;
			htmlViewer.ResizeHTMLControl(ClientRectangle);
		}
		protected override void OnResize(EventArgs e)
		{
			base.OnResize (e);
			if(created)
				htmlViewer.ResizeHTMLControl(ClientRectangle);
		}

		public string HtmlText
		{
			get { return htmlViewer.HtmlString; }
			set { htmlViewer.DisplayText(value); }
		}
	}
}
