using System;
using System.Collections;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Resources;
using System.Threading;
using System.Windows.Forms;

using Microsoft.WindowsCE.Forms;

 
namespace ihook.PocketWidgets.Utils
{
	internal class Palmtop
	{
		InputPanel inputPanel = new InputPanel();
		public Rectangle VisibleDesktop
		{
			get { return inputPanel.VisibleDesktop; }
		}
		public bool Enabled
		{
			get { return inputPanel.Enabled; }
			set { inputPanel.Enabled = value; }
		}
		public event EventHandler EnabledChanged
		{
			add { inputPanel.EnabledChanged += value; }
			remove { inputPanel.EnabledChanged -= value; }
		}
	}

	/// <summary>
	/// this class is meant to replace the InputPanel.
	/// It has the same functionality but should work well
	/// (do nothing but not bug) on the desktop
	/// </summary>
	public class DesktopInputPanel
	{
		Palmtop palmtop;
		public DesktopInputPanel()
		{
			if(WinAPI.IsDevice)
				palmtop = new Palmtop();
		}
		static DesktopInputPanel shared;
		public static DesktopInputPanel Shared
		{
			get
			{
				if(shared == null)
					shared = new DesktopInputPanel();
				return shared;
			}
		}

		public Rectangle VisibleDesktop
		{
			get
			{
				if(palmtop != null)
					return palmtop.VisibleDesktop;
				return new Rectangle(0, 0, 240, 320);
			}
		}
		public bool Enabled
		{
			get
			{
				if(palmtop != null)
					return palmtop.Enabled;
				return true;
			}
			set
			{
				if(palmtop != null)
					palmtop.Enabled = value;
			}
		}
		public event EventHandler EnabledChanged
		{
			add
			{
				if(palmtop != null)
					palmtop.EnabledChanged += value;
			}
			remove
			{
				if(palmtop != null)
					palmtop.EnabledChanged -= value;
			}
		}
	}
} 