using System;
using System.Drawing;
using System.Collections;
using System.Globalization;
using System.Windows.Forms;
using System.Data;
using System.IO;

using ihook.PocketWidgets;
using ihook.PocketWidgets.Editors;
using ihook.PocketWidgets.Table;
using ihook.PocketWidgets.Table.Renderers;
using ihook.PocketWidgets.Utils;

namespace testPocket
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form, IRowHeaderCellRenderer
	{
		private Microsoft.WindowsCE.Forms.InputPanel inputPanel1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;

		TableControl tControl = new TableControl();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeImages();

			Text = "Title here !";

			//TestNTable();
			TestLTable();
			//TestMyListEditor();
		}
		void TestMyListEditor()
		{
			EditableListEditor ele = new EditableListEditor();
			ele.CellEditor = new UpDownNumEditor();
			ele.ListSource = new int[] { 1, 2, 4, 8, 16, 32, 64, 128, 256 };
			ele.Location = new Point(20, 20);
			ele.Parent = this;
			ele.BringToFront();
		}
		void TestNTable()
		{
			DataGrid dg = new DataGrid();
			dg.DataSource = CreateTable();
			dg.Bounds = new Rectangle(5, 5, 220, 260);
			Controls.Add(dg);
		}
		void TestLTable()
		{
			tControl = new TableControl();
			tControl.Model = new DataTableModel(CreateTable());
			tControl.Body.DefaultColWidth = 50;
			tControl.Renderers.RowHeader = this;
			tControl.Editor[0] = new TableEditor(new TimeEditor());
			tControl.Editor[2] = new TableEditor(new DateEditor());
			tControl.Editor[4] = new TableEditor(new ListEditor(new string[]{"one", "two", "three", "four", "five"}));
			tControl.Editor[6] = new TableEditor(new DateTimeEditor());
			tControl.Renderers[0] = new DateTimeRenderer(ihook.PocketWidgets.Editors.DateEditorFormat.Time);
			tControl.Renderers[2] = new DateTimeRenderer(ihook.PocketWidgets.Editors.DateEditorFormat.ShortDate);
			tControl.Renderers[2] = new DateTimeRenderer(ihook.PocketWidgets.Editors.DateEditorFormat.ShortDate);
			tControl.Renderers[6] = new DateTimeRenderer(ihook.PocketWidgets.Editors.DateEditorFormat.ShortDate);

			tControl.Bounds = panel1.ClientRectangle;
			tControl.Parent = panel1;
		}

		DataTable CreateTable()
		{
			DataTable dt = new DataTable("ATable");
			for(int i = 0; i<8; i++)
				dt.Columns.Add("Col "+i);

			dt.Columns[0].ColumnName = "Time";
			dt.Columns[0].DataType = typeof(DateTime);
			dt.Columns[1].ColumnName = "Decimal";
			dt.Columns[1].DataType = typeof(decimal);
			dt.Columns[2].ColumnName = "Date";
			dt.Columns[2].DataType = typeof(DateTime);
			dt.Columns[3].ColumnName = "Bool";
			dt.Columns[3].DataType = typeof(bool);
			dt.Columns[4].ColumnName = "List";
			dt.Columns[5].ColumnName = "Integer";
			dt.Columns[5].DataType = typeof(int);
			dt.Columns[6].ColumnName = "DateTime";
			dt.Columns[6].DataType = typeof(DateTime);
			dt.Columns[7].ColumnName = "Culture";

			for(int i = 0; i<50; i++)
				dt.Rows.Add(dt.NewRow());
			return dt;
		}
		Hashtable icons = new Hashtable();
		Icon GetIcon(string name)
		{
			Icon ic = (Icon) icons[name];
			if(ic == null)
			{
				ic = new Icon(GetType().Assembly.GetManifestResourceStream("testPocket."+name));
				icons[name] = ic;
			}
			return ic;
		}
		void InitializeImages()
		{
			foreach(string s in new string[]{"dll.ico",
			"editor.ico",
			"folder.ico",
			"glmodel.ico",
			"hd.ico",
			"openfolder.ico",
			"otherfiles.ico",
			"viewer.ico",
			"world.ico"})
				imageList1.Images.Add(GetIcon(s));
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.inputPanel1 = new Microsoft.WindowsCE.Forms.InputPanel();
			this.imageList1 = new System.Windows.Forms.ImageList();
			this.panel1 = new System.Windows.Forms.Panel();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.Add(this.menuItem2);
			// 
			// menuItem2
			// 
			this.menuItem2.MenuItems.Add(this.menuItem1);
			this.menuItem2.MenuItems.Add(this.menuItem3);
			this.menuItem2.MenuItems.Add(this.menuItem4);
			this.menuItem2.MenuItems.Add(this.menuItem5);
			this.menuItem2.MenuItems.Add(this.menuItem6);
			this.menuItem2.Text = "Dialog";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Text = "Save Pic";
			this.menuItem1.Click += new System.EventHandler(this.HSave);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			// 
			// panel1
			// 
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Size = new System.Drawing.Size(224, 248);
			// 
			// menuItem3
			// 
			this.menuItem3.Text = "Hide Panel";
			this.menuItem3.Click += new System.EventHandler(this.HHidePanel);
			// 
			// menuItem4
			// 
			this.menuItem4.Text = "Show Panel";
			this.menuItem4.Click += new System.EventHandler(this.HShowPanel);
			// 
			// menuItem5
			// 
			this.menuItem5.Text = "Remove";
			this.menuItem5.Click += new System.EventHandler(this.HRemove);
			// 
			// menuItem6
			// 
			this.menuItem6.Text = "Put";
			this.menuItem6.Click += new System.EventHandler(this.HPut);
			// 
			// Form1
			// 
			this.Controls.Add(this.panel1);
			this.Menu = this.mainMenu1;
			this.Text = "Form1";

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			//Application.Run(new Form1());
			ApplicationEx.Run(new Form1());
		}
		#region IRowHeaderCellRenderer Members

		public void PaintRowHeaderCell(Graphics g, TableControl tc, Rectangle r, int row, ITableModel model)
		{
			g.DrawIcon(GetIcon("editor.ico"), r.X+1, r.Y+1);
		}

		#endregion

		#region ICell Members

		public void OnMouseDown(TableControl tc, int row, int col, MouseEventArgs e)
		{
			// TODO:  Add Form1.OnMouseDown implementation
		}

		#endregion

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			TestDialog td = new TestDialog();
			td.Dialog.ShowModal(this);
		}

		private void HSave(object sender, System.EventArgs e)
		{
//			SaveFileDialog sfd = new SaveFileDialog();
//			sfd.Filter = "Bitmap|*.bmp";
//			DialogResult dr = sfd.ShowDialog();
//			if(dr != DialogResult.OK)
//				return;
//			BitmapFile.SaveToFile(this, sfd.FileName, 24, 240, 320);
		}

		private void HHidePanel(object sender, System.EventArgs e)
		{
			panel1.Visible = false;
		}
		private void HShowPanel(object sender, System.EventArgs e)
		{
			panel1.Visible = true;
		}

		private void HRemove(object sender, System.EventArgs e)
		{
			panel1.Parent = null;
		}
		private void HPut(object sender, System.EventArgs e)
		{
			panel1.Parent = this;
		}
	}
}
