using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;

namespace ihookDB.Widgets.Paint
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class PaintForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.RadioButton radioPen;
		private System.Windows.Forms.RadioButton radioLine;
		private System.Windows.Forms.RadioButton radioCircle;
		private System.Windows.Forms.RadioButton radioRect;
		private System.Windows.Forms.RadioButton radioSpray;
		internal System.Windows.Forms.CheckBox checkFill;
		private System.Windows.Forms.Panel pPaint;
		private System.Windows.Forms.Panel pColor;
		private System.Windows.Forms.MainMenu mainMenu1;
		internal System.Windows.Forms.TrackBar tThick;

		internal ColorChooser cChooser = new ColorChooser();
		private System.Windows.Forms.Button button1;
		internal PaintArea paintArea;
		public PaintForm()
		{
			InitializeComponent();

			radioPen.Checked = true;

			cChooser.Bounds = pColor.Bounds;
			cChooser.Parent = this;
			pColor.Parent = null;

			paintArea = new PaintArea(this);
			paintArea.Bounds = pPaint.Bounds;
			paintArea.Parent = this;
			pPaint.Parent = null;
		}
		public Image Image
		{
			get { return paintArea.Image; }
			set { paintArea.Model = value; }
		}

		public enum Tools : byte
		{
			Pen,
			Line,
			Ellipse,
			Rectangle,
			SprayCan
		}
		public Tools Tool
		{
			get
			{
				if(radioPen.Checked)
					return Tools.Pen;
				else if(radioLine.Checked)
					return Tools.Line;
				else if(radioCircle.Checked)
					return Tools.Ellipse;
				else if(radioRect.Checked)
					return Tools.Rectangle;
				else if(radioSpray.Checked)
					return Tools.SprayCan;
				else
					return Tools.Pen;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PaintForm));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.pPaint = new System.Windows.Forms.Panel();
			this.radioPen = new System.Windows.Forms.RadioButton();
			this.radioLine = new System.Windows.Forms.RadioButton();
			this.radioCircle = new System.Windows.Forms.RadioButton();
			this.radioRect = new System.Windows.Forms.RadioButton();
			this.radioSpray = new System.Windows.Forms.RadioButton();
			this.tThick = new System.Windows.Forms.TrackBar();
			this.checkFill = new System.Windows.Forms.CheckBox();
			this.pColor = new System.Windows.Forms.Panel();
			this.button1 = new System.Windows.Forms.Button();
			// 
			// pPaint
			// 
			this.pPaint.BackColor = System.Drawing.Color.AntiqueWhite;
			this.pPaint.Enabled = ((bool)(resources.GetObject("pPaint.Enabled")));
			this.pPaint.Location = ((System.Drawing.Point)(resources.GetObject("pPaint.Location")));
			this.pPaint.Size = ((System.Drawing.Size)(resources.GetObject("pPaint.Size")));
			this.pPaint.Text = resources.GetString("pPaint.Text");
			this.pPaint.Visible = ((bool)(resources.GetObject("pPaint.Visible")));
			// 
			// radioPen
			// 
			this.radioPen.Enabled = ((bool)(resources.GetObject("radioPen.Enabled")));
			this.radioPen.Font = ((System.Drawing.Font)(resources.GetObject("radioPen.Font")));
			this.radioPen.Location = ((System.Drawing.Point)(resources.GetObject("radioPen.Location")));
			this.radioPen.Size = ((System.Drawing.Size)(resources.GetObject("radioPen.Size")));
			this.radioPen.Text = resources.GetString("radioPen.Text");
			this.radioPen.Visible = ((bool)(resources.GetObject("radioPen.Visible")));
			// 
			// radioLine
			// 
			this.radioLine.Enabled = ((bool)(resources.GetObject("radioLine.Enabled")));
			this.radioLine.Font = ((System.Drawing.Font)(resources.GetObject("radioLine.Font")));
			this.radioLine.Location = ((System.Drawing.Point)(resources.GetObject("radioLine.Location")));
			this.radioLine.Size = ((System.Drawing.Size)(resources.GetObject("radioLine.Size")));
			this.radioLine.Text = resources.GetString("radioLine.Text");
			this.radioLine.Visible = ((bool)(resources.GetObject("radioLine.Visible")));
			// 
			// radioCircle
			// 
			this.radioCircle.Enabled = ((bool)(resources.GetObject("radioCircle.Enabled")));
			this.radioCircle.Font = ((System.Drawing.Font)(resources.GetObject("radioCircle.Font")));
			this.radioCircle.Location = ((System.Drawing.Point)(resources.GetObject("radioCircle.Location")));
			this.radioCircle.Size = ((System.Drawing.Size)(resources.GetObject("radioCircle.Size")));
			this.radioCircle.Text = resources.GetString("radioCircle.Text");
			this.radioCircle.Visible = ((bool)(resources.GetObject("radioCircle.Visible")));
			// 
			// radioRect
			// 
			this.radioRect.Enabled = ((bool)(resources.GetObject("radioRect.Enabled")));
			this.radioRect.Font = ((System.Drawing.Font)(resources.GetObject("radioRect.Font")));
			this.radioRect.Location = ((System.Drawing.Point)(resources.GetObject("radioRect.Location")));
			this.radioRect.Size = ((System.Drawing.Size)(resources.GetObject("radioRect.Size")));
			this.radioRect.Text = resources.GetString("radioRect.Text");
			this.radioRect.Visible = ((bool)(resources.GetObject("radioRect.Visible")));
			// 
			// radioSpray
			// 
			this.radioSpray.Enabled = ((bool)(resources.GetObject("radioSpray.Enabled")));
			this.radioSpray.Font = ((System.Drawing.Font)(resources.GetObject("radioSpray.Font")));
			this.radioSpray.Location = ((System.Drawing.Point)(resources.GetObject("radioSpray.Location")));
			this.radioSpray.Size = ((System.Drawing.Size)(resources.GetObject("radioSpray.Size")));
			this.radioSpray.Text = resources.GetString("radioSpray.Text");
			this.radioSpray.Visible = ((bool)(resources.GetObject("radioSpray.Visible")));
			// 
			// tThick
			// 
			this.tThick.Enabled = ((bool)(resources.GetObject("tThick.Enabled")));
			this.tThick.LargeChange = 3;
			this.tThick.Location = ((System.Drawing.Point)(resources.GetObject("tThick.Location")));
			this.tThick.Minimum = 1;
			this.tThick.Orientation = ((System.Windows.Forms.Orientation)(resources.GetObject("tThick.Orientation")));
			this.tThick.Size = ((System.Drawing.Size)(resources.GetObject("tThick.Size")));
			this.tThick.Text = resources.GetString("tThick.Text");
			this.tThick.Value = 1;
			this.tThick.Visible = ((bool)(resources.GetObject("tThick.Visible")));
			// 
			// checkFill
			// 
			this.checkFill.Enabled = ((bool)(resources.GetObject("checkFill.Enabled")));
			this.checkFill.Font = ((System.Drawing.Font)(resources.GetObject("checkFill.Font")));
			this.checkFill.Location = ((System.Drawing.Point)(resources.GetObject("checkFill.Location")));
			this.checkFill.Size = ((System.Drawing.Size)(resources.GetObject("checkFill.Size")));
			this.checkFill.Text = resources.GetString("checkFill.Text");
			this.checkFill.Visible = ((bool)(resources.GetObject("checkFill.Visible")));
			// 
			// pColor
			// 
			this.pColor.BackColor = System.Drawing.Color.LightCoral;
			this.pColor.Enabled = ((bool)(resources.GetObject("pColor.Enabled")));
			this.pColor.Location = ((System.Drawing.Point)(resources.GetObject("pColor.Location")));
			this.pColor.Size = ((System.Drawing.Size)(resources.GetObject("pColor.Size")));
			this.pColor.Text = resources.GetString("pColor.Text");
			this.pColor.Visible = ((bool)(resources.GetObject("pColor.Visible")));
			// 
			// button1
			// 
			this.button1.Enabled = ((bool)(resources.GetObject("button1.Enabled")));
			this.button1.Font = ((System.Drawing.Font)(resources.GetObject("button1.Font")));
			this.button1.Location = ((System.Drawing.Point)(resources.GetObject("button1.Location")));
			this.button1.Size = ((System.Drawing.Size)(resources.GetObject("button1.Size")));
			this.button1.Text = resources.GetString("button1.Text");
			this.button1.Visible = ((bool)(resources.GetObject("button1.Visible")));
			this.button1.Click += new System.EventHandler(this.HFill);
			// 
			// PaintForm
			// 
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.button1);
			this.Controls.Add(this.pColor);
			this.Controls.Add(this.checkFill);
			this.Controls.Add(this.tThick);
			this.Controls.Add(this.radioSpray);
			this.Controls.Add(this.radioRect);
			this.Controls.Add(this.radioCircle);
			this.Controls.Add(this.radioLine);
			this.Controls.Add(this.radioPen);
			this.Controls.Add(this.pPaint);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.Menu = this.mainMenu1;
			this.Text = resources.GetString("$this.Text");
			this.Visible = ((bool)(resources.GetObject("$this.Visible")));

		}
		#endregion

		private void HFill(object sender, System.EventArgs e)
		{
			Color c = cChooser.SelectedColor;
			Graphics g = paintArea.ImageGraphics;
			Image img = paintArea.Image;
			Brush brush = new SolidBrush(c);
			g.FillRectangle(brush, 0, 0, img.Width, img.Height);
			brush.Dispose();
			paintArea.Invalidate();
		}
	}
}
